#ifndef COMPLEX_H
#define COMPLEX_H

class Complex
{
public:
    Complex(double _re = 0.0, double _im = 0.0);
    Complex(const Complex& rhs);

    double  squareMag() const;
    double  mag() const;
    float   arg() const;
    Complex conj() const;
    static Complex Sin(const Complex z);
    static Complex Cos(const Complex z);

    void    operator=(const Complex rhs);
    Complex operator+(const Complex rhs) const;
    Complex operator-(const Complex rhs) const;
    Complex operator*(const double rhs) const;
    Complex operator*(const Complex rhs) const;
    Complex operator/(const double rhs) const;
    Complex operator/(const Complex rhs) const;

    double re;
    double im;
};

#endif // COMPLEX_H
